#ifndef __GUI_H__
#define __GUI_H__

void ClearScreen(void);
void DrawScreen(void);
void UpdateScreen(void);

extern uint8_t PROGMEM SmallFont[];
extern uint8_t PROGMEM BigFont[];

#define GUI_MAX_ELEMENTS	10
int NUM_ELEMENTS;
struct _GUI_ELEMENT_
{
  int x;
  int y;
  int w;
  int h;
  int state;
  int type;
  char text[12];
  char text2[12];
  void (*callback)(void);
}GUI_ELEMENT[GUI_MAX_ELEMENTS];

int GUI_LAST_ACTIVE;

struct _GUI_COLOR__
{
  int br;
  int bg;
  int bb;
  int r;
  int g;
  int b;
  int fr;
  int fg;
  int fb;
  int ar;
  int ag;
  int ab;
  int tr;
  int tg;
  int tb;
}GUI_COLOR;
int GUI_STYLE;
#define STYLE_HIDDEN	0
#define STYLE_BLUE	1
#define STYLE_RED	2
#define STYLE_GREEN	3

char GUI_TOPLINE[24];
char GUI_BOTTOMLINE[24];

void gui_style(int theme);
void guiShowElement(int num);
int8_t gui_checkElement(int num, int x, int y);
void guiSetElementState(int num, int state);
void guiNewElement(int type, char *text, char *text2, int x, int y, int w, int h, void (*cb)(void));
void gui_stop(void);
void gui_check(int x, int y);
void gui_start(void);
void gui_update_thermometer(int x,float value);
void gui_draw_thermometer(int x, char* text1, char* text2);
void gui_top_line(char *line);
void gui_bottom_line(char *line);
void gui_refresh(void);

#define gui_state_inactive	0
#define gui_state_active	1
#define gui_state_pressed	2

#define gui_type_button			0
#define gui_type_round_button		1
#define gui_type_small_button		2
#define gui_type_small_round_button	3
#define gui_type_bottom_button		4
#define gui_type_thermometer		5

#endif