#ifndef _IO_H_
#define _IO_H_

/** ****************************************************************
*	Definitions for port actions
*******************************************************************/
#define OUTPUT_LOW		0
#define OUTPUT_HIGH		1
#define OUTPUT			2
#define INPUT			3
#define INPUT_HIGH		4
#define INPUT_LOW		5
#define ENABLE_PULLUP		6
#define DISABLE_PULLUP		7

/** ****************************************************************
*	Definitions of Arduino Mega pins
*******************************************************************/
#define D0		0
#define D1		1
#define D2		2
#define D3		3
#define D4		4
#define D5		5
#define D6		6
#define D7		7
#define D8		8
#define D9		9
#define D10		10
#define D11		11
#define D12		12
#define D13		13
#define D14		14
#define D15		15
#define D16		16
#define D17		17
#define D18		18
#define D19		19
#define D20		20
#define D21		21
#define D22		22
#define D23		23
#define D24		24
#define D25		25
#define D26		26
#define D27		27
#define D28		28
#define D29		29
#define D30		30
#define D31		31
#define D32		32
#define D33		33
#define D34		34
#define D35		35
#define D36		36
#define D37		37
#define D38		38
#define D39		39
#define D40		40
#define D41		41
#define D42		42
#define D43		43
#define D44		44
#define D45		45
#define D46		46
#define D47		47
#define D48		48
#define D49		49
#define D50		50
#define D51		51
#define D52		52
#define D53		53
#define D54		54
#define D55		55
#define D56		56
#define D57		57
#define D58		58
#define D59		59
#define D60		60
#define D61		61
#define D62		62
#define D63		63
#define D64		64
#define D65		65
#define D66		66
#define D67		67
#define D68		68
#define D69		69
#define A0		54
#define A1		55
#define A2		56
#define A3		57
#define A4		58
#define A5		59
#define A6		60
#define A7		61
#define A8		62
#define A9		63
#define A10		64
#define A11		65
#define A12		66
#define A13		67
#define A14		68
#define A15		69
#define PWM0		2
#define PWM1		3
#define PWM2		4
#define PWM3		5
#define PWM4		6
#define PWM5		7
#define PWM6		8
#define PWM7		9
#define PWM8		10
#define PWM9		11
#define PWM10		12
#define PWM11		13
#define SDA		20
#define SDL		21
#define RX		0
#define TX		1
#define RX1		19
#define TX1		18
#define RX2		17
#define TX2		16
#define RX3		15
#define TX3		14

/** ****************************************************************
*	set_io
*
*	@Brief Set status of a pin
*
*	@Param ionr	Number of the Arduino Mega pin
*	@Param status	Status to set
*			0 = Output low
*			1 = Output high
*			2 = Output
*			3 = Input
*			4 = Input with internal pullup
*			5 = Input without internal pullup
*			6 = Enable internal pullup
*			7 = Disable internal pullup
*
*	@Return none
*******************************************************************/
extern void set_io(uint8_t pin, uint8_t status);

/** ****************************************************************
*	get_io
*
*	@Brief Get status of a pin
*
*	@Param pin	Number of the Arduino Mega pin
*
*	@Return 	0 = LOW, 1=HIGH, 255 = Port unknown
*******************************************************************/
extern uint8_t get_io(uint8_t pin);

#endif /* _IO_H_ */
